// Correction application Chapitre 8
// Macroéconomie quantitative (2014, éd. Ellipses) 
// par Christophe Cahn

// Ce fichier permet de reproduire les élements contenu
// dans le fichier App_8_estimation.pdf disponible sur le site
// www.christophecahn.fr/macroquant

// Filename : App_8_1c.mod
// Application : Matlab/Octave
// Date : 24-04-2014
// Christophe Cahn (c) 2014

// question 1c

var p y i nu_i nu_p nu_n ;
varexo en ei ep ;

parameters k b ap ay rho_p rho_i rho_n ;
b = .98 ;
k = .01 ;
ap = 1.2 ;
ay = .1 ;
rho_n = 0.8 ;
rho_i = 0.8 ;
rho_p = 0.8 ;

model;

    b*p(+1) + k*y + nu_p - p ;
    y = y(+1) - (i - p(+1) - nu_n) ;
    i = ap*p + ay*y + nu_i ;
    
    nu_n = rho_n*nu_n(-1) + en ;
    nu_i = rho_i*nu_i(-1) + ei ;
    nu_p = rho_p*nu_p(-1) + ep ;
end;

shocks;
var en; stderr .01 ;
var ei; stderr .01 ;
var ep; stderr .01 ;
end;

estimated_params;
	k ,    .01;
	ap ,  1.2 ;
	ay ,   .1 ;
	rho_n, .8 ;
	rho_i, .8 ;
	rho_p, .8 ;
	stderr en, .01 ;
	stderr ei, .01 ;
	stderr ep, .01 ;
end ;

varobs y p i ;

estimation(datafile='data',graph_format=pdf);